<template>
  <v-container>
    <v-row>
      <v-col>
        <v-textarea
          v-model="currentFeedback"
          name="feedback-input"
          label="Please provide your feedback here"
          rows="2"
          outlined
          autofocus
          auto-grow
          hide-details
          @keyup.enter.ctrl.exact="submitFeedback"
          @keyup.esc="collapseTextField"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <label-selector
          id="comment-label-selector"
          :assigned-to-feedback="false"
          :line-no="lineNo"
          :labels-unchanged="labelsUnchanged"
          :labels-added="labelsAdded"
          :labels-removed="labelsRemoved"
          @label-added="labelAdded"
          @label-removed="labelRemoved"
          @submit-shortcut="submitFeedback"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <v-btn
          id="submit-comment"
          color="success"
          @click="submitFeedback"
        >
          <v-icon>check</v-icon>Submit
        </v-btn>
        <v-btn
          id="cancel-comment"
          @click="collapseTextField"
        >
          <v-icon>cancel</v-icon>cancel
        </v-btn>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue'
import Component, { mixins } from 'vue-class-component'
import { Prop, Watch } from 'vue-property-decorator'
import { SubmissionNotes, subNotesEventBus } from '@/store/modules/submission-notes'
import LabelSelector from '@/components/feedback_labels/LabelSelector.vue'
import { FeedbackComment, SubmissionType } from '@/models'
import commentLabelSelector from '@/components/mixins/commentLabelSelector'

@Component({
  components: {
    LabelSelector
  }
})
export default class CommentForm extends mixins(commentLabelSelector) {
  @Prop({ type: String, default: '' }) readonly feedback!: string
  @Prop({ type: String, required: true }) readonly lineNo!: string

  currentFeedback = this.feedback
  labelsUnchanged: number[] = this.getUnchangedLabels()
  labelsAdded: number[] = this.getAddedLabels()
  labelsRemoved: number[] = this.getRemovedLabels()

  selectInput (event: Event) {
    if (event !== null) {
      const target = event.target as HTMLTextAreaElement
      target.select()
    }
  }

  collapseTextField () {
    this.$emit('collapseFeedbackForm')
    subNotesEventBus.$emit('submissionChanged')
  }

  /**
   * Adds label pk to the array of added labels
   * or adds already removed labels to unchanged array
   */
  labelAdded (pk: number) {
    if (this.labelsRemoved.includes(pk)) {
      this.labelsUnchanged.push(pk)
      this.labelsRemoved = this.labelsRemoved.filter((val) => {
        return val !== pk
      })
    } else if (!this.labelsAdded.includes(pk) &&
      !this.labelsUnchanged.includes(pk))
    {
      this.labelsAdded.push(pk)
    }
  }

  /**
   * Adds label pk to the array of removed labels
   * or removes already added labels from the list of added labels
   */
  labelRemoved (pk: number) {
    if (this.labelsAdded.includes(pk)) {
      this.labelsAdded = this.labelsAdded.filter((val) => {
        return val !== pk
      })
    } else if (!this.labelsRemoved.includes(pk)) {
      this.labelsRemoved.push(pk)
      this.labelsUnchanged = this.labelsUnchanged.filter((val) => {
        return val !== pk
      })
    }
  }

  submitFeedback () {
    const text = this.currentFeedback
    const labels = this.labelsUnchanged.concat(this.labelsAdded)

    if (text === '' && labels.length === 0) {
      return this.collapseTextField()
    }

    const payload: {lineNo: number, comment: Partial<FeedbackComment>} = {
      lineNo: Number(this.lineNo),
      comment: {
        text: text,
        labels: labels,
      }
    }

    if (this.labelsAdded.length === 0 && this.labelsRemoved.length === 0) {
      delete payload.comment.labels
    }

    SubmissionNotes.UPDATE_FEEDBACK_LINE(payload)
    this.collapseTextField()
  }
}

</script>

<style scoped>
  v-text-field {
    padding-top: 0px;
  }
</style>
